#!/bin/bash
set -ex

# see man flock "EXAMPLES"
[ "${FLOCKER}" != "$0" ] && exec env FLOCKER="$0" flock -enF "$0" "$0" "$@" || :

FIMEX_VCROSS="{{ metws_job_scripts }}/util/fimex-vcross"
FIMEX_VERIF="{{ metws_job_scripts }}/util/fimex-verif"
DATADIR='{{ nwp.datadir }}'

mkdir -p "$DATADIR"
rsync -avz -e "ssh -i {{ devcoopmetno_sshkey_path }}" "{{ devcoopmetno_user }}@{{ devcoopmetno_host }}:{{ nwp.name }}/" "$DATADIR/"

# begin create vertical cross section files
{% for pattern in nwp.vcross_patterns %}
find "$DATADIR/" -name "{{ pattern }}" | xargs -r -L 1 "$FIMEX_VCROSS"
{% endfor %}
# end create vertical cross section files

{% if nwp.verif_patterns is defined %}
# begin create verification files
{% for pattern in nwp.verif_patterns %}
find "$DATADIR/" -name "{{ pattern }}" | xargs -r -L 1 "$FIMEX_VERIF"
{% endfor %}
# end create verification files

{% endif %}
# Clean up old data, remove files with modification times older than 14 days
find "$DATADIR" -mtime "+14" -exec /bin/rm '{}' \;

{% if node_exporter_textfile_dir is defined %}
NAME=devcoop_nwp_from_metno_latest
PROMDIR={{ node_exporter_textfile_dir | quote }}
PROMFILE="$PROMDIR/devcoop_nwp_from_metno.prom"
GAUGE_SIZE="${NAME}_size_bytes"
GAUGE_MTIME="${NAME}_timestamp"

if test ! -f "$PROMFILE" ; then
    cat <<EOF > "$PROMFILE.$$"
# TYPE $GAUGE_SIZE gauge
# UNIT $GAUGE_SIZE bytes
# HELP $GAUGE_SIZE Size of $NAME
# TYPE $GAUGE_MTIME gauge
# UNIT $GAUGE_MTIME seconds
# HELP $GAUGE_MTIME Timestamp (seconds since epoch) of $NAME
EOF
else
    cp -vf  "$PROMFILE" "$PROMFILE.$$"
fi

LATEST=`find "$DATADIR" -type f | sort -n | tail -n1`
if test -n "$LATEST" ; then
    LATEST_SIZE=`stat -c "%s" "$LATEST"`
    LATEST_MTIME=`stat -c "%Y" "$LATEST"`
else
    LATEST_SIZE="0"
    LATEST_MTIME="0"
fi

NEW_SIZE="$GAUGE_SIZE{nwp=\"{{ nwp.name }}\"} $LATEST_SIZE"
NEW_MTIME="$GAUGE_MTIME{nwp=\"{{ nwp.name }}\"} $LATEST_MTIME"

if grep -q "^$GAUGE_SIZE{" "$PROMFILE.$$" ; then
    sed -i -e "s/$GAUGE_SIZE{.*/$NEW_SIZE/" "$PROMFILE.$$"
else
    echo "$NEW_SIZE" >> "$PROMFILE.$$"
fi
if grep -q "^$GAUGE_MTIME{" "$PROMFILE.$$" ; then
    sed -i -e "s/$GAUGE_MTIME{.*/$NEW_MTIME/" "$PROMFILE.$$"
else
    echo "$NEW_MTIME" >> "$PROMFILE.$$"
fi

mv -vf "$PROMFILE.$$" "$PROMFILE"
{% endif %}
